#include <WiFi.h>
#include <Servo.h>
#include <iostream>
#include <ctime>
#include <ratio>
#include <chrono>
#include <cortina.h>
using namespace std::chrono;


Servo myservo; // Creamos objeto servo motor

static const int servoPin = "VALOR";//colocar el valor del pin que controlara el servomotor 
// remplazar esta parte con las credenciales de internet a la cual deseas conectar tu placa esp32
const char* ssid     = "SSID";
const char* password = "CONTRASEÑA";

WiFiServer server(80);//setiamos el puerto del servidor al puerto 80

String header; //Variable para guardar las HTML request del servidor
//posiciones que se utilizaran luego para sacar el valor de interes del metodo get
int pos1 = 0;
int pos2 = 0;

// Decode HTTP GET value
String valueString = String(0);//Varaible conde se guardaralos HTTP GET del servidor

// variables que se utilizaran en el contador en el Loop() para la pagina web y para llamar a las funciones de mover la cortina de la clase cortina
clock_t ini,fin;
unsigned long currentTime = millis();
unsigned long previousTime = 0; 
// Define timeout time in milliseconds (example: 2000ms = 2s)
const long timeoutTime = 2000;
//atributos de la cortina, cambiar por los valores de la cortina que quieras usar, las unidades de radio y largo tienes que ser las mismas "[cm] o [m]"
double radio = "radio";
double rpm = "rpm"; // revoluciones por minuto del servomotor usado
double largo= "largo";

LargoCortina *cortina = new LargoCortina(radio,rpm,largo);
  
void setup() {
  Serial.begin(115200);
  double l_max = 45;
  myservo.attach(servoPin); //Conectamos el servomotor al pin de interez 
  // conectamos la esp 32 a nuestra red wifi
  Serial.print("Con necting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  // imprimero por el puerto serial la direccion ip del server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();
  

}

void loop(){
  WiFiClient client = server.available();//espera a que se conecte un usuario
  high_resolution_clock::time_point t1 = high_resolution_clock::now();
  
  if (client) {  // si se conecta un nuevo usario se entrara a este if                         
    currentTime = millis();
    previousTime = currentTime;
    Serial.println("New Client.");          
    String currentLine = "";                
    while (client.connected() && currentTime - previousTime <= timeoutTime) { //mientras el usario este conectado
      currentTime = millis();
      if (client.available()) {             
        char c = client.read();             
        Serial.write(c);                    
        header += c;
        if (c == '\n') {                    
          if (currentLine.length() == 0) {
            // Mostrar mensaje de que se logro la conexion
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println();

            // carga la pagina web
            client.println("<!DOCTYPE html><html>");
            client.println("<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">");
            client.println("<link rel=\"icon\" href=\"data:,\">");
            client.println("<style>body { text-align: center; font-family: \"Trebuchet MS\", Arial; margin-left:auto; margin-right:auto;}");
            client.println(".slider { width: 300px; }</style>");
            client.println("<script src=\"https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js\"></script>");         
            client.println("</head><body><h1>Cortina domotica</h1>");
            client.println("<p><button id= \"button\"onclick= \"up()\" class=\"button1\">Up</button></p>");
            client.println("<p><button id=\"button\" onclick= \"stop()()\"class=\"button2\">Stop</button></p>");          
            client.println("<p><button id=\"button\" onclick= \"down()\"class=\"button2\">Down</button></p>");
            client.println("<script> function up() {$.get(\"/?value=\" + 1 + \"&\");    }");
            client.println("function stop() {$.get(\"/?value=\" + 0 + \"&\");    }  ");
            client.println("function down() {$.get(\"/?value=\" + 2 + \"&\");    }  </script>");    
            client.println("</body></html>");     
            
            //GET /?value=180& HTTP/1.1
            if(header.indexOf("GET /?value=")>=0) {
              pos1 = header.indexOf('=');
              pos2 = header.indexOf('&');
              valueString = header.substring(pos1+1, pos2);
            }
            client.println();
            break;
          } else {
            currentLine = "";
          }
        } else if (c != '\r') { 
          currentLine += c;
        }
      }
        
    }
    header = "";
    //cerrar la conexion
    client.stop();
    Serial.println("Client disconnected.");
    Serial.println("");
    
    if (valueString.toInt() == 1){ //subir cortina
      myservo.write(0);                        
    }             
    else if (valueString.toInt() == 2){ //bajar cortina
      myservo.write(180);        
    }
    else if (valueString.toInt() == 0){ //detener cortina
      myservo.write(90);
    }
  }
  if (valueString.toInt() == 1){
    high_resolution_clock::time_point t2 = high_resolution_clock::now();
    duration<double> time_span = duration_cast<duration<double>>(t2 - t1);
    cortina->AumentarLargoFuncRPS(time_span.count());
    if (cortina->getTope()){
      myservo.write(90);
      valueString = String(0);
      }
  }
  else if (valueString.toInt() == 2){
    high_resolution_clock::time_point t2 = high_resolution_clock::now();
    duration<double> time_span = duration_cast<duration<double>>(t2 - t1);
    cortina->DisminuirLargoFuncRPS(time_span.count());
    if (cortina->getTope()){
      myservo.write(90);
      valueString = String(0);                           
    }
  }
}



               
